 $prog &HFF , &H0F , &HD9 , &H00       ' generated. Take care that the chip supports all fuse bytes.
$regfile = "M32DEF.DAT"
$crystal = 16000000
$hwstack = 128
$swstack = 64

'***********************************************************
'***                                                     ***
'***    FPGA-val keszitett LCD vezerlo teszt program     ***
'***                                                     ***
'***                                                     ***
'***                                                     ***
'***                                                     ***
'***********************************************************
'** Megrendelo   : Sajat magam :-)                       ***
'** Verzio       : V2.0                                  ***
'** Start project: 2008.10.15.                           ***
'** End project  : 2009.12.31                            ***
'** Compiler     : BASCOM AVR V1.11.9.3                  ***
'***********************************************************
'                           __________   __________
'                           |         \_/         |
' A0 <-------------    PB0 =| 1 (T0)     (ADC0) 40|= PA0  <-------------- Poti1
'                           |                     |
' A1 <-------------    PB1 =| 2 (T1)     (ADC1) 39|= PA1
'                           |                     |
' A2 <-------------    PB2 =| 3 (AIN0)   (ADC2) 38|= PA2
'                           |                     |
' ( A4 ) <---------    PB3 =| 4 (AIN1)   (ADC3) 37|= PA3
'                           |                     |
' SW1 ------------->   PB4 =| 5 (SS)     (ADC4) 36|= PA4
'                           |                     |
' SW3 ------------->   PB5 =| 6 (MOSI)   (ADC5) 35|= PA5
'                           |                     |
' SW2 ------------->   PB6 =| 7 (MISO)   (ADC6) 34|= PA6
'                           |                     |
'                      PB7 =| 8 (SCK)    (ADC7) 33|= PA7
'                           |                     |
' RESET  ----------> RESET =| 9                 32|= AREF <--------------- +5V
'                           |                     |
' +5V   ----------->   VCC =|10                 31|= GND  <--------------- GND
'                           |                     |
' GND   ----------->   GND =|11                 30|= AVCC <--------------- +5V
'                           |                     |
' Kvarc <----------- XTAL2 =|12         (TOSC2) 29|= PC7  <--------------> D7
'                           |                     |
' Kvarc -----------> XTAL1 =|13         (TOSC1) 28|= PC6  <--------------> D6
'                           |                     |
' Txd   ----------->   PD0 =|14 (RxD)     (TDI) 27|= PC5  <--------------> D5
'                           |                     |
' Rxd   <-----------   PD1 =|15 (TxD)     (TDO) 26|= PC4  <--------------> D4
'                           |                     |
'                      PD2 =|16 (INT0)    (TMS) 25|= PC3  <--------------> D3
'                           |                     |
'                      PD3 =|17 (INT1)    (TCK) 24|= PC2  <--------------> D2
'                           |                     |
'                      PD4 =|18 (OC1B)    (SDA) 23|= PC1  <--------------> D1
'                           |                     |
'                      PD5 =|19 (OC1A)    (SCL) 22|= PC0  <--------------> D0
' ______                    |                     |                        ______
' CPU_RD <----------   PD6 =|20 (ICP1)    (OC2) 21|= PD7  ---------------> CPU_WR
'                           |_____________________|
'




'----------------------------------------------------------------------
Portb = 255

Config Portb.0 = Output       'A0
Config Portb.1 = Output       'A1
Config Portb.2 = Output       'A2
Config Portb.3 = Input       'nc
Config Portb.4 = Input       'SW1
Config Portb.5 = Input       'SW3
Config Portb.6 = Input       'SW2
Config Portb.7 = Input       'nc.

Cpu_address Alias Portb

Sw1 Alias Pinb.4
Sw2 Alias Pinb.6
Sw3 Alias Pinb.5

'----------------------------------------------------------------------
Portc = 0

Config Portd.0 = Input       'NC.
Config Portd.1 = Input       'NC.
Config Portd.2 = Input       'NC.
Config Portd.3 = Input       'NC.
Config Portd.4 = Input       'NC.
Config Portd.5 = Input       'NC.
Config Portd.6 = Output       'CPU_RD
Config Portd.7 = Output       'CPU_WR

Cpu_wr Alias Portd.7
Cpu_rd Alias Portd.6
Portd = 255

'----------------------------------------------------------------------
Portc = 0

Config Portc = Output

Cpu_read_data Alias Pinc
Cpu_write_data Alias Portc

'----------------------------------------------------------------------

Stop Watchdog

Declare Sub Cpu_write(byval Address As Byte , Byval Adat As Byte)
Declare Function Cpu_read(byval Address As Byte) As Byte
Declare Sub Cpu_poke(byval Address As Word , Byval Adat As Byte )
Declare Function Cpu_peek(byval Address As Word ) As Byte
Declare Sub Txt_locate(byval Cx As Byte , Byval Cy As Byte )
Declare Sub Cpu_print(byval Szoveg As String )
Declare Sub Cls_layer(byval Layer_sorszam As Byte )
Declare Sub Set_vram_addr
Declare Sub Set_lcd(byval Bit_nev As Byte , Byval Adat As Byte)
Declare Function Vram_read(byval Address As Word ) As Byte
Declare Function Cgram_read(byval Address As Word ) As Byte

Declare Sub Push_reg4
Declare Sub Pop_reg4
Declare Sub Push_reg5
Declare Sub Pop_reg5
Declare Sub Push_reg6
Declare Sub Pop_reg6
Declare Sub Push_reg7
Declare Sub Pop_reg7


Dim Vram As Word       'A video RAM cimet ebbol olvassak a rutinok
Dim Tmp_reg4 As Byte
Dim Tmp_reg5 As Byte
Dim Tmp_reg6 As Byte
Dim Tmp_reg7 As Byte

'**************************************************
'***                                            ***
'***      Az LCD terito FPGA regiszterei        ***
'***                                            ***
'*** 8db regiszter amelyek a REG0 s a REG1 ki- ***
'***       vetelevel csak olvashatoak.          ***
'***                                            ***
'**************************************************

Dim Reg0 As Byte       ' RAM adat irhato/olvashato
Dim Reg1 As Byte       ' Iras eseten RAM cim also byte
                        ' olvasaskor a karaktergenerator adat
Reg1 = 0

Dim Reg2 As Byte       ' RAM cim felso byte
Reg2 = 0


Dim Reg3 As Byte       ' RAM lapozo regiszter
Reg3 = 0
'
'REG3  0  0  0  0  0  0  0  0  <--- reset utani allapot
'
'     b7 b6 b5 b4 b3 b2 b1 b0
'     |  |  |  |  |  |  |  |
'     |  |  |  |  |  |  |   --> CPU RAM A16
'     |  |  |  |  |  |   -----> Layer 0 RAM cim A16 ( 1 bit/pixel )
'     |  |  |  |  |   --------> Layer 1 RAM cim A16 ( 1 bit/pixel )
'     |  |  |  |   -----------> Layer 2 RAM cim A16 ( 1 bit/pixel )
'     |  |  |   --------------> Layer 3 RAM cim A16 ( 1 bit/pixel )
'     |  |   -----------------> Layer 4 RAM cim A16 ( 2 bit/pixel )
'     |  ---------------------> Layer 5 RAM cim A16 ( karakteres  )
'      -----------------------> Display invertalas  ( 0=normal, 1=inverez )
Const Cpu_ram_a16 = 30
Const Layer0_a16 = 31
Const Layer1_a16 = 32
Const Layer2_a16 = 33
Const Layer3_a16 = 34
Const Layer4_a16 = 35
Const Layer5_a16 = 36
Const Display_inv = 37


Dim Reg4 As Byte       ' Karakter attributum
'
'REG4  0  0  0  0  0  0  0  0  <--- reset utani allapot
Reg4 = 0
'
'     b7 b6 b5 b4 b3 b2 b1 b0
'     |  |  |  |  |  |  -----
'     |  |  |  |  |  |    |
'     |  |  |  |  |  |     ---> Fenyero 0...3
'     |  |  |  |  |   --------> Atlatszosag                       (0=atlatszo)
'     |  |  |  |   -----------> Extra uses sor atlatszosag        (0=atlatszo)
'     |  |  |   --------------> Inverz engedelyezes               (0=nem inverz)
'     |  |   -----------------> Inverz villogas                   (0=nem villog)
'     |  ---------------------> Normal villogas                   (0 nem villog)
'      -----------------------> A 2.karaktergenerator kivalasztasa(0=1.kargen.)
'
'Ha engedelyezve van az automatikus karakter attributum iras, akkor a
'karakterteruletre torteno irasakor automatikusan a karakterhez tartozo
'attributum is beirodik a video ram-ba ennek a regiszternek megfeleloen
'
Const Car_bright = 40
Const Car_transp = 41
Const Car_ext_line_transp = 42
Const Car_inv = 43
Const Car_inv_flash = 44
Const Car_flash = 45
Const Car_gen_sel = 46



Dim Reg5 As Byte       ' Layer, display es automatikus
                        ' ram cim noveles engedelyezes
                        ' Az layer es az LCD engedelyezes csak
                        ' minden kepterites elejen van figyelve,

'REG5  0  0  0  0  0  0  0  0  <--- reset utani allapot
Reg5 = 0
'
'     b7 b6 b5 b4 b3 b2 b1 b0
'     |  |  |  |  |  |  |  |
'     |  |  |  |  |  |  |   --> Layer 0 engedelyezes        ( 0=tiltva )
'     |  |  |  |  |  |   -----> Layer 1 engedelyezes        ( 0=tiltva )
'     |  |  |  |  |   --------> Layer 2 engedelyezes        ( 0=tiltva )
'     |  |  |  |   -----------> Layer 3 engedelyezes        ( 0=tiltva )
'     |  |  |   --------------> Layer 4 engedelyezes        ( 0=tiltva )
'     |  |   -----------------> Layer 5 engedelyezes        ( 0=tiltva )
'     |  ---------------------> LCD DISPEN engedelyezes     ( 0=tiltva )
'      -----------------------> Automatikus RAM cim noveles ( 0=tiltva )
'
'Ha engedelyezve van az automatikus cimnoveles, akkor minden iras vagy olvasas
'utan a a RAM cim 1-el novekszik.
Const Layer0_en = 50
Const Layer1_en = 51
Const Layer2_en = 52
Const Layer3_en = 53
Const Layer4_en = 54
Const Layer5_en = 55
Const Lcd_en = 56
Const Auto_incr = 57

Dim Reg6 As Byte       ' 1bit/pixel grafikus layer-ek fenyereje
'
'REG6  1  1  1  1  1  1  1  1  <--- reset utani allapot ( max. fenyero )
Reg6 = 255
'
'     b7 b6 b5 b4 b3 b2 b1 b0
'     ----- ----- ----- -----
'       |     |     |     |
'       |     |     |      ---> Layer 0 fenyero 0...3
'       |     |      ---------> Layer 1 fenyero 0...3
'       |      ---------------> Layer 2 fenyero 0...3
'        ---------------------> Layer 3 fenyero 0...3
Const Layer0_bright = 60
Const Layer1_bright = 61
Const Layer2_bright = 62
Const Layer3_bright = 63


Dim Reg7 As Byte       ' Karaktergenerator beallitas
'
'REG7  0  0  0  0  0  0  0  0  <--- reset utani allapot
Reg7 = &B00100100
'
'     b7 b6 b5 b4 b3 b2 b1 b0
'     |  |  -------- --------
'     |  |     |        |
'     |  |     |         -----> Karakter magassag 8...15
'     |  |      --------------> Karaktergenerator kar. magassag 8...15
'     |   --------------------> Belso/kulso kar.generator ( 0 = belso )
'      -----------------------> Auto. attributum iras engedelyezes ( 0=tiltva )
'
Const Car_size = 70
Const Cgen_size = 71
Const Ext_car_gen = 72
Const Auto_attr = 73
'
' Ha a belso karaktergenerator engedelyezve van, akkor a 2. kulso
' karaktergenerator az 1. lapon a ram vegen a DEC 60000 cimnel kezdodik.
' Ha tiltva van, akkor az 1. lapon talalhato karaktergenerator lessz az
' az alapertelmezett es a masodik lapon talalhato lessz a 2. karaktergenerator.


'**************************************************
'***                                            ***
'***       A 128 kbyte-os RAM felosztasa        ***
'***                                            ***
'**************************************************
'
'  DEC     0 -  9599  Layer 0 ( 1bit/pixel )
'  DEC  9600 - 19199  Layer 1 ( 1bit/pixel )
'  DEC 19200 - 28799  Layer 2 ( 1bit/pixel )
'  DEC 28800 - 38399  Layer 3 ( 1bit/pixel )
'  DEC 38400 - 57599  Layer 4 ( 2bit/pixel )
'  DEC 57600 - 59999  Layer 5 ( karakteres )
'  DEC 60000 - 63072  2./1. karaktergenerator
'                     A belso karaktergenerator vagy 8x8-as vagy
'                     8x12-es. Ez attol fugg, hogy az FPGA flash beprogramoza-
'                     sakor melyiket rakom bele.

Const Layer0_start = 0
Const Layer1_start = 9600
Const Layer2_start = 19200
Const Layer3_start = 28800
Const Layer4_start = 38400
Const Layer5_start = 57600
'A karakteres layer5 1200 byte hosszu, de utana meg 1200 byte van
'az attributumoknak ezert osszesen 2400 byte-hosszu
Const Car_gen_start = 60000

'A lapozoregiszterektol fuggoen az adott layer vagy az elso vagy a masodik
'64 kbyte-os lapon helyezkedik el.
'A belso karaktergenerator tiltasa utan az alapertelmezett 1. karaktergenerator
'az elso 64 kbyte-os ram-ban van a 2. pedig a masodik 64 kbyte-os lapon.
'A belso karaktergenerator NEM hozzaferheto a CPU szamara !
'A teritett karakter magassaga es a karaktergeneratorban letarot karakterek
'hossza kulonbozhet. Nagyobb karaktermeretnel a hianyzo karakterkep helyen
'extra ures sorok lesznek megjelenitve.
'EGYSZERRE 512 FELE KARAKTERT LEHET MEGJELENITENI


Const Yes = 1
Const No = 0

'LCD Inicializalas

'FONTOS !!!!
'Az FPGA felprogramozasa miatt kell 500ms-os varakozas es csak
'utana lehet baszogatni a chip-et!
Waitms 500

'Page regiszter
Set_lcd Cpu_ram_a16 , 0       '  0/1
Set_lcd Layer0_a16 , 0       '   0/1
Set_lcd Layer1_a16 , 0       '   0/1
Set_lcd Layer2_a16 , 0       '   0/1
Set_lcd Layer3_a16 , 0       '   0/1
Set_lcd Layer4_a16 , 0       '   0/1
Set_lcd Layer5_a16 , 0       '   0/1
Set_lcd Display_inv , No       ' Yes/No


'Karakter attributum
Set_lcd Car_bright , 0       '           0, 1, 2, 3
Set_lcd Car_transp , Yes       '         Yes/No
Set_lcd Car_ext_line_transp , Yes       'Yes/No
Set_lcd Car_inv , No       '             Yes/No
Set_lcd Car_inv_flash , No       '       Yes/No
Set_lcd Car_flash , No       '           Yes/No
Set_lcd Car_gen_sel , 0       '          0/1


'Layer engedelyezes
Set_lcd Layer0_en , Yes       ' Yes/No
Set_lcd Layer1_en , Yes       ' Yes/No
Set_lcd Layer2_en , Yes       ' Yes/No
Set_lcd Layer3_en , Yes       ' Yes/No
Set_lcd Layer4_en , Yes       ' Yes/No
Set_lcd Layer5_en , Yes       'Yes/No
Set_lcd Lcd_en , Yes       '   Yes/No
Set_lcd Auto_incr , Yes       'Yes/No

'1bit/pixel-es layer fenyero
Set_lcd Layer0_bright , 3       '0, 1, 2, 3
Set_lcd Layer1_bright , 3       '0, 1, 2, 3
Set_lcd Layer2_bright , 3       '0, 1, 2, 3
Set_lcd Layer3_bright , 3       '0, 1, 2, 3


'Karaktergenerator beallitas
Set_lcd Car_size , 4       '    0, 1, 2, 3
Set_lcd Cgen_size , 4       '   0, 1, 2, 3
Set_lcd Ext_car_gen , No       'Yes/No
Set_lcd Auto_attr , Yes       ' Yes/No


Dim I As Byte
Dim Ii As Word
Dim J As Byte
Dim Jj As Word
Dim Jj2 As Word
Dim S As String * 1
Dim Xx As Byte


'Layer-ek torlese
Cls_layer 0
Cls_layer 1
Cls_layer 2
Cls_layer 3
Cls_layer 4
Cls_layer 5


Do
   Set_lcd Layer0_en , No       ' Yes/No
   Set_lcd Layer1_en , No       ' Yes/No
   Set_lcd Layer2_en , No       ' Yes/No
   Set_lcd Layer3_en , No       ' Yes/No
   Set_lcd Layer4_en , No       ' Yes/No
   Set_lcd Layer5_en , Yes       'Yes/No
   Cls_layer 5
   Set_lcd Car_bright , 3
   Txt_locate 5 , 5
   Cpu_print "SW1 Karakteres demo"
   Txt_locate 5 , 7
   Cpu_print "SW2 1bit/pixel demo"
   Txt_locate 5 , 9
   Cpu_print "SW3 2bit/pixel demo"
   While Sw1 = 1 And Sw2 = 1 And Sw3 = 1
   Wend
   If Sw1 = 0 Then Goto Karakter_demo
Loop


Karakter_demo:

'Layer torlese
Cls_layer 5

'Az osszes karakter kiiratasa a kepernyore
Txt_locate 0 , 0
Set_lcd Car_bright , 3
Cpu_print "8x12 karakter : "
For I = 0 To 255
   S = Chr(i)
   Cpu_print S
Next I

'A kulso karaktergeneratorba 128 dupla szeles karakter
'letarolasa a belso karaktergeneratorban levo adatokbol

Jj = Car_gen_start
Jj2 = Jj + 12
J = 1
For Ii = 0 To 1536       '3072
   I = Cgram_read(ii)
   Xx.7 = I.7
   Xx.6 = I.7
   Xx.5 = I.6
   Xx.4 = I.6
   Xx.3 = I.5
   Xx.2 = I.5
   Xx.1 = I.4
   Xx.0 = I.4
   Cpu_poke Jj , Xx
   Xx.7 = I.3
   Xx.6 = I.3
   Xx.5 = I.2
   Xx.4 = I.2
   Xx.3 = I.1
   Xx.2 = I.1
   Xx.1 = I.0
   Xx.0 = I.0
   Cpu_poke Jj2 , Xx
   Incr Jj
   Incr Jj2
   Incr J
   If J = 13 Then
      Jj = Jj + 12
      Jj2 = Jj2 + 12
      J = 1
   End If
Next Ii

'Az osszes dupla szeles karakter kiiratasa a kepernyore
Txt_locate 0 , 8
Cpu_print "8x12 szeles karakter : "
Set_lcd Car_bright , 3
Set_lcd Car_gen_sel , 1       '          0/1

For I = 2 To 255
   S = Chr(i)
   Cpu_print S
Next I

Set_lcd Car_gen_sel , 0       '          0/1

Txt_locate 4 , 16
Cpu_print "SW1 normal display"
Txt_locate 4 , 17
Cpu_print "SW2 inverz display"
Txt_locate 4 , 18
Cpu_print "SW3 karakteres demo folytatas..."
Txt_locate 4 , 19
Cpu_print "RESET kezdo menu"


Do
   If Sw1 = 0 Then Set_lcd Display_inv , No       ' Yes/No
   If Sw2 = 0 Then Set_lcd Display_inv , Yes       ' Yes/No
   If Sw3 = 0 Then Exit Do
Loop

'Layer torlese
Cls_layer 5


'Karakter attributum
Set_lcd Car_bright , 0       '           0, 1, 2, 3
Set_lcd Car_transp , Yes       '         Yes/No
Set_lcd Car_ext_line_transp , Yes       'Yes/No
Set_lcd Car_inv , No       '             Yes/No
Set_lcd Car_inv_flash , No       '       Yes/No
Set_lcd Car_flash , No       '           Yes/No
Set_lcd Car_gen_sel , 0       '          0/1

Set_lcd Car_bright , 0       '           0, 1, 2, 3
Txt_locate 0 , 1
Cpu_print "Fenyero = 0"

Set_lcd Car_bright , 1       '           0, 1, 2, 3
Txt_locate 0 , 2
Cpu_print "Fenyero = 1"

Set_lcd Car_bright , 2       '           0, 1, 2, 3
Txt_locate 0 , 3
Cpu_print "Fenyero = 2"

Set_lcd Car_bright , 3       '           0, 1, 2, 3
Txt_locate 0 , 4
Cpu_print "Fenyero = 3"

Set_lcd Car_inv , Yes       '             Yes/No
Txt_locate 0 , 5
Cpu_print "Inverz karakter"

Set_lcd Car_inv , No       '             Yes/No
Set_lcd Car_flash , Yes       '           Yes/No
Txt_locate 0 , 6
Cpu_print "Villogo karakter"

Set_lcd Car_inv , No       '             Yes/No
Set_lcd Car_flash , No       '           Yes/No
Set_lcd Car_inv_flash , Yes       '       Yes/No
Txt_locate 0 , 7
Cpu_print "Invertalva villogo karakter"

Set_lcd Car_inv , No       '             Yes/No
Set_lcd Car_flash , No       '           Yes/No
Set_lcd Car_inv_flash , No       '       Yes/No

Txt_locate 10 , 15
Cpu_print "SW1 normal display "
Txt_locate 10 , 16
Cpu_print "SW2 inverz display "
Txt_locate 10 , 17
Cpu_print "RESET kezdo menu"



Do
   If Sw1 = 0 Then Set_lcd Display_inv , No       ' Yes/No
   If Sw2 = 0 Then Set_lcd Display_inv , Yes       ' Yes/No
Loop


'Maximum 255 karakteres szoveg kiirasa a Txt_locate altal
'beallitott karakterpoziciotol
Sub Cpu_print(byval Szoveg As String )
   Local Print_pozicio As Byte
   Local Szoveg_hossz As Byte
   Local Karakter_kod As Byte
   Local Karakter As String * 1
   Szoveg_hossz = Len(szoveg)
   If Szoveg_hossz = 0 Then Exit Sub
   For Print_pozicio = 1 To Szoveg_hossz
      Karakter = Mid(szoveg , Print_pozicio , 1)
      Karakter_kod = Asc(karakter)
      Cpu_write 0 , Karakter_kod
   Next Print_pozicio
End Sub


'Beallitja a video RAM cimet a karekteres layer megfelelo cimere
'az "x" sor es az "y" oszlopnak megfeleloen
Sub Txt_locate(byval Cx As Byte , Byval Cy As Byte )
   Vram = Cy * 40
   Vram = Vram + Cx
   Vram = Vram + Layer5_start
   Set_vram_addr
End Sub


' A kivalasztott layer torlese
Sub Cls_layer(byval Layer_sorszam As Byte )
   Local Layer_hossz As Word
   Local Ciklus As Word
   'Szoveges layernel az attributum iras engedelyezese
   If Layer_sorszam = 5 Then Set_lcd Auto_attr , 1
   'Automatikus cimnoveles engedelyezese
   Set_lcd Auto_incr , 1
   Select Case Layer_sorszam
      Case 0 : Vram = Layer0_start
      Case 1 : Vram = Layer1_start
      Case 2 : Vram = Layer2_start
      Case 3 : Vram = Layer3_start
      Case 4 : Vram = Layer4_start
      Case 5 : Vram = Layer5_start
   End Select
   Select Case Layer_sorszam
      Case 0 To 3 : Layer_hossz = 9600
      Case 4 : Layer_hossz = 19200
      Case 5 : Layer_hossz = 1200
   End Select
   Set_vram_addr
   For Ciklus = 1 To Layer_hossz
      Cpu_write 0 , 0
   Next Ciklus
End Sub

'A Vram valtozonak megfelelo cimet beirja az FPGA RAM cimregiszterebe
Sub Set_vram_addr
   Local Vram_hi As Byte
   Local Vram_lo As Byte
   Vram_hi = High(vram)
   Vram_lo = Low(vram)
   Cpu_write 2 , Vram_hi
   Cpu_write 1 , Vram_lo
End Sub

'A Vram-nak megfelelo cimre ir
Sub Cpu_poke(byval Address As Word , Byval Adat As Byte )
   Vram = Address
   Set_vram_addr
   Cpu_write 0 , Adat
End Sub

'A Vram-nak megfelelo cimrol olvas
Function Cpu_peek(byval Address As Word ) As Byte
   Vram = Address
   Set_vram_addr
   Cpu_peek = Cpu_read(0)
End Function

'A belso karaktergeneratorbol olvas
'A cimbol csak 0...3072 kozotti cimtartomanyt veszi figyelembe
Function Cgram_read(byval Address As Word ) As Byte
   Vram = Address
   Set_vram_addr
   Cgram_read = Cpu_read(1)
End Function

'A video ram-bol olvas
Function Vram_read(byval Address As Word ) As Byte
   Vram = Address
   Set_vram_addr
   Vram_read = Cpu_read(0)
End Function


'Az kivalasztott FPGA regiszter irasa
Sub Cpu_write(byval Address As Byte , Byval Adat As Byte)
   Config Portc = Output
   Cpu_address = &B11111000 Or Address
   Cpu_write_data = Adat
   Cpu_rd = 1
   Cpu_wr = 0
   Cpu_wr = 1
   Config Portc = Input
End Sub

'Az kivalasztott FPGA regiszter olvasasa
Function Cpu_read(byval Address As Byte) As Byte
   Config Portc = Input
   Cpu_address = &B11111000 Or Address
   Cpu_rd = 0
   Cpu_wr = 1
   Cpu_read = Cpu_read_data
   Cpu_rd = 1
End Function

'Az FPGA regiszterek mentese
'Ez arra lehet jo, hogy egy szubrutinbol valo visszateres utan nem
'baszodnak el a hasznalt regiszterek
Sub Push_reg4 : Tmp_reg4 = Reg4 : Cpu_write 4 , Reg4 : End Sub
Sub Pop_reg4 : Reg4 = Tmp_reg4 : Cpu_write 4 , Reg4 : End Sub
Sub Push_reg5 : Tmp_reg5 = Reg5 : Cpu_write 5 , Reg5 : End Sub
Sub Pop_reg5 : Reg5 = Tmp_reg5 : Cpu_write 5 , Reg5 : End Sub
Sub Push_reg6 : Tmp_reg6 = Reg6 : Cpu_write 6 , Reg6 : End Sub
Sub Pop_reg6 : Reg6 = Tmp_reg6 : Cpu_write 6 , Reg6 : End Sub
Sub Push_reg7 : Tmp_reg7 = Reg7 : Cpu_write 7 , Reg7 : End Sub
Sub Pop_reg7 : Reg7 = Tmp_reg7 : Cpu_write 7 , Reg7 : End Sub


'Az FPGA vezerlo regeisztereinek a bit szintu beallitasat vegzi
Sub Set_lcd(byval Bit_nev As Byte , Byval Adat As Byte)
   Select Case Bit_nev
      Case 30 : Reg3.0 = Adat.0
      Case 31 : Reg3.1 = Adat.0
      Case 32 : Reg3.2 = Adat.0
      Case 33 : Reg3.3 = Adat.0
      Case 34 : Reg3.4 = Adat.0
      Case 35 : Reg3.5 = Adat.0
      Case 36 : Reg3.6 = Adat.0
      Case 37 : Reg3.7 = Adat.0
      Case 41 : Reg4.2 = Not Adat.0
      Case 42 : Reg4.3 = Not Adat.0
      Case 43 : Reg4.4 = Adat.0
      Case 44 : Reg4.5 = Adat.0
      Case 45 : Reg4.6 = Adat.0
      Case 46 : Reg4.7 = Adat.0
      Case 50 : Reg5.0 = Adat.0
      Case 51 : Reg5.1 = Adat.0
      Case 52 : Reg5.2 = Adat.0
      Case 53 : Reg5.3 = Adat.0
      Case 54 : Reg5.4 = Adat.0
      Case 55 : Reg5.5 = Adat.0
      Case 56 : Reg5.6 = Adat.0
      Case 57 : Reg5.7 = Adat.0
      Case 72 : Reg7.6 = Adat.0
      Case 73 : Reg7.7 = Adat.0
   End Select
   If Bit_nev = 40 Then
      Reg4.0 = Adat.0
      Reg4.1 = Adat.1
   End If
   If Bit_nev = 60 Then
      Reg6.0 = Adat.0
      Reg6.1 = Adat.1
   End If
   If Bit_nev = 61 Then
      Reg6.2 = Adat.0
      Reg6.3 = Adat.1
   End If
   If Bit_nev = 62 Then
      Reg6.4 = Adat.0
      Reg6.5 = Adat.1
   End If
   If Bit_nev = 63 Then
      Reg6.6 = Adat.0
      Reg6.7 = Adat.1
   End If
   If Bit_nev = 70 Then
      Reg7.0 = Adat.0
      Reg7.1 = Adat.1
      Reg7.2 = Adat.2
   End If
   If Bit_nev = 71 Then
      Reg7.3 = Adat.0
      Reg7.4 = Adat.1
      Reg7.5 = Adat.2
   End If
   Select Case Bit_nev
      Case 30 To 37 : Cpu_write 3 , Reg3
      Case 40 To 46 : Cpu_write 4 , Reg4
      Case 50 To 57 : Cpu_write 5 , Reg5
      Case 60 To 63 : Cpu_write 6 , Reg6
      Case 70 To 73 : Cpu_write 7 , Reg7
   End Select
End Sub